# -*- coding:utf-8 -*-

from torlite.core import tools
from pycate.model.catalog_model import MCatalog
import config
from pycate.core import base_handler


class InfoHandler(base_handler.PycateBaseHandler):
    def initialize(self, hinfo=''):
        # self.userid = self.get_secure_cookie('login_user').decode('utf-8')
        self.init_condition(config.mongo_collection_name)
        # self.mlink = MLink(self.city_name)
        self.mcat = MCatalog()

    def get(self, input=''):
        if len(input) == 36:
            self.view(input)
        else:
            self.render('404.html')

    def is_viewable(self, info):

        if info['userid'] == self.userinfo.user_name:
            # 如果是用户自己的，当然可以查看
            return True
        if info['def_valid'] != 1:
            return (False)
        if info['def_banned'] == 1:
            return (False)
        return True

    def view(self, uuid):
        info = self.minfo.get_by_id(uuid)
        if info is None:
            # 如果资源不存在
            self.set_status(404)
            self.render('404_view.html')
            return (False)
        elif self.is_viewable(info):
            pass
        else:
            self.render('404.html')
            return

        cat_id = info['catid'][0]
        parent_id = cat_id[:2] + '00'
        parent_catname = self.mcat.get_by_id(parent_id).catname
        catname = self.mcat.get_by_id(cat_id).catname

        daohang_str = '<a href="/">数据中心</a>'
        daohang_str += ' &gt; <a href="/list/{0}">{1}</a>'.format(parent_id, parent_catname)
        daohang_str += ' &gt; <a href="/list/{0}">{1}</a>'.format(cat_id, catname)

        imgname = ''
        has_image = 0
        img_url = ''
        if len(info['mymps_img']) > 0:
            imgname = info['mymps_img'][0]
            has_image = 1
            img_url = self.static_url(imgname)

        if self.userinfo.user_name == info['userid']:
            operate_str = ''


        else:
            operate_str = '''<span><a onclick="js_show_page('/user/shoucang/{0}')">收藏</a></span>'''.format(uuid)

        kwd = {
            'img_url': img_url,
            'daohangstr': daohang_str,
            'has_image': has_image,
            'parentid': parent_id,
            'parentlist': self.mcat.get_parent_list(),
            'oprt_str': operate_str,
        }
        self.update_info_when_view(info)
        self.render('{0}/autogen/view/view_{1}.html'.format(self.template_dir_name, info['catid'][0]),
                    kwd=kwd,
                    post_info=info)

    def update_info_when_view(self, info):
        uuid = info['def_uid']
        self.minfo.update_view_count(uuid)
