# -*- coding:utf-8 -*-
'''
一些形式单一的操作
'''

# from pycate.core import pycate_cfg
from torlite.core import tools
from pycate.model.catalog_model import MCatalog
# from pycate.model.refresh_model import MRefresh
from pycate.core import base_handler

import  config


class OpHandler(base_handler.PycateBaseHandler):
    def initialize(self, hinfo=''):
        self.init_condition(config.mongo_collection_name)
        # self.mrefresh = MRefresh()
        self.mcat = MCatalog()


    def op_redirect(self, input):
        '''

        '''
        tmp_uu = input.split(r'/')
        uid = tmp_uu[0]
        action = tmp_uu[1]
        if len(tmp_uu) == 3:
            re_str = '''/tui/{0}/{1}'''.format(tmp_uu[2], action)
        else:
            re_str = '''/filter/{0}'''.format(action)

        self.redirect(re_str)

    def active_info(self, def_uid, sig):
        '''
        switch the status.
        用于刷新、推广、置顶
        '''
        info_dic = self.minfo.get_by_id(def_uid)
        # 值大，则权重高。
        weight = self.mcat.get_weight_id(info_dic['catid'][0])
        sigit = 'def_' + sig
        if info_dic[sigit] == 0:
            # 避免已经进行过操作
            info_dic[sigit] = 1
            sig_time = 'def_' + sig + '_out_time'
            timestamp = tools.timestamp() + int( config.timeout[sig] / weight)
            info_dic[sig_time] = timestamp
            # 首先保证更新成功
            if self.minfo.update(def_uid, info_dic) == True:
                return True


    def update_userinfo(self, sig, parentid=''):
        if parentid == '':
            self.muser_num.num_decrease(sig)
        else:
            self.muser_vip.num_decrease(sig, parentid)




class DeleteHandler(OpHandler):
    '''
    url:  /refresh/uid/cation/parentid
    '''

    def get(self, input=''):
        tmp_uu = input.split(r'/')
        uid = tmp_uu[0]
        self.edit_delete(uid)
        self.op_redirect(input)

    def edit_delete(self, def_uid):
        info = self.minfo.get_by_id(def_uid)
        if self.is_editable(info) == True:
            self.minfo.delete_by_uid(def_uid)

    def is_editable(self, info):
        '''
        谁发布的谁编辑
        '''
        if info['userid'] == self.user_name:
            return True
        return False


class RefreshHandler(OpHandler):
    '''
    url:  /refresh/uid/cation/parentid
    '''
    def get(self, input=''):
        url_arr = input.split(r'/')
        uid = url_arr[0]
        action = url_arr[1]
        if len(url_arr) == 3:
            parentid = url_arr[2]
            if self.muser_vip.get_refresh_num() > 0:
                if self.active_info(uid, 'refresh') == True:
                    self.update_userinfo('refresh', parentid)
                    self.set_status(200)
        else:
            if self.muser_num.get_refresh_num() > 0:
                if self.active_info(uid, 'refresh') == True:
                    self.update_userinfo('refresh')
                    self.set_status(200)

        self.op_redirect(input)


class TuiguangHandler(OpHandler):
    '''
    url:  /tuiguang/uid/cation/parentid
    '''

    def get(self, input=''):
        tmp_arr = input.split(r'/')
        if len(tmp_arr) == 3:
            pass
        else:
            return False
        uid, action, parentid = input.split(r'/')

        if self.muser_vip.get_tuiguang_num(parentid) > 0:
            if self.active_info(uid, 'tuiguang') == True:
                self.active_info(uid, 'refresh')
                self.update_userinfo('tuiguang', parentid)

        self.op_redirect(input)


class ZhidingHandler(OpHandler):
    '''
    url:  /tuiguang/uid/cation
    '''

    def get(self, input=''):
        tmp_uu = input.split(r'/')
        if len(tmp_uu) == 2:
            pass
        else:
            self.render('404.html')
            return False
        uid = tmp_uu[0]

        if self.muser_num.get_zhiding_num() > 0:
            if self.active_info(uid, 'zhiding') == True:
                self.update_userinfo('zhiding')

        self.op_redirect(input)