# -*- coding:utf-8 -*-


from pycate.core import base_handler
import config
import redis
import tornado.web

redisvr = redis.Redis(host='localhost',
                      port=6379, db=0,
                      password=None,
                      socket_timeout=None,
                      connection_pool=None,
                      charset='utf-8',
                      errors='strict',
                      unix_socket_path=None)


class InfoLabelHandler(base_handler.PycateBaseHandler):
    def initialize(self, hinfo=''):
        self.init_condition(config.pycate_sig)

    def get(self, input=''):
        if len(input) > 0:
            ip_arr = input.split(r'/')
        if len(ip_arr) == 1:
            self.list(input)
        elif len(ip_arr) == 2:
            if ip_arr[0] == 'remove':
                self.remove_redis_keyword(ip_arr[1])

            else:
                self.list(ip_arr[0], ip_arr[1])

    def post(self, url_str=''):
        if len(url_str) > 0:
            url_arr = url_str.split('/')
        if url_arr[0] == 'edit':
            self.edit(url_arr[1])


    @tornado.web.authenticated
    def remove_redis_keyword(self, kw):
        redisvr.srem(config.redis_kw + self.userinfo.user_name, kw)
        self.redirect('/')

    @tornado.web.authenticated
    def list(self, tag_slug, cur_p=''):

        redisvr.sadd(config.redis_kw + self.userinfo.user_name, tag_slug)

        if cur_p == '':
            current_page_number = 1
        else:
            current_page_number = int(cur_p)

        tag_name = 'fd'
        kwd = {
            'tag_name': tag_name,
            'tag_slug': tag_slug,

            'title': tag_name,

        }

        infos = self.minfo.query_by_tagname(tag_slug),

        self.render('{0}/label/list.html'.format(self.template_dir_name),
                    infos=infos,
                    # unescape=tornado.escape.xhtml_unescape,
                    kwd=kwd,
                    pager='',
                    userinfo=self.userinfo,
                    # self.gen_pager(tag_slug, page_num, current_page_number),
                    )

    def gen_pager(self, cat_slug, page_num, current):
        # cat_slug 分类
        # page_num 页面总数
        # current 当前页面
        if page_num == 1:
            return ''

        pager_shouye = '''
        <li class="pure-menu-item first {0}">
        <a class="pure-menu-link" href="/tag/{1}">&lt;&lt; 首页</a>
                    </li>'''.format('hidden' if current <= 1 else '', cat_slug)

        pager_pre = '''
                    <li class="pure-menu-item previous {0}">
                    <a class="pure-menu-link" href="/tag/{1}/{2}">&lt; 前页</a>
                    </li>
                    '''.format('hidden' if current <= 1 else '', cat_slug, current - 1)
        pager_mid = ''
        for ind in range(0, page_num):
            tmp_mid = '''
                    <li class="pure-menu-item page {0}">
                    <a class="pure-menu-link" href="/tag/{1}/{2}">{2}</a></li>
                    '''.format('selected' if ind + 1 == current else '', cat_slug, ind + 1)
            pager_mid += tmp_mid
        pager_next = '''
                    <li class="pure-menu-item next {0}">
                    <a class="pure-menu-link" href="/tag/{1}/{2}">后页 &gt;</a>
                    </li>
                    '''.format('hidden' if current >= page_num else '', cat_slug, current + 1)
        pager_last = '''
                    <li class="pure-menu-item last {0}">
                    <a class="pure-menu-link" href="/tag/{1}/{2}">末页
                        &gt;&gt;</a>
                    </li>
                    '''.format('hidden' if current >= page_num else '', cat_slug, page_num)
        pager = pager_shouye + pager_pre + pager_mid + pager_next + pager_last
        return (pager)
